package com.tencent.flutter_integration;

import android.content.Context;
import android.util.AttributeSet;
import android.util.Log;

import java.lang.reflect.Method;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import io.flutter.embedding.android.FlutterView;
import io.flutter.embedding.engine.FlutterEngine;

public class HookFlutterView extends FlutterView {

    public HookFlutterView(@NonNull Context context) {
        super(context);
    }

    public HookFlutterView(@NonNull Context context, @NonNull RenderMode renderMode) {
        super(context, renderMode);
    }

    public HookFlutterView(@NonNull Context context, @NonNull TransparencyMode transparencyMode) {
        super(context, RenderMode.surface, transparencyMode);
    }

    public HookFlutterView(@NonNull Context context, @NonNull RenderMode renderMode, @NonNull TransparencyMode transparencyMode) {
        super(context, renderMode, transparencyMode);
    }

    public HookFlutterView(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    @Override
    public void detachFromFlutterEngine() {
    }

    @Override
    public void attachToFlutterEngine(FlutterEngine flutterEngine) {
        super.attachToFlutterEngine(flutterEngine);
        try {
            Class<?> clz = FlutterView.class;
            Method m = clz.getDeclaredMethod("sendViewportMetricsToFlutter");
            m.setAccessible(true);
            m.invoke(this);

        } catch (Exception e) {
            Log.w("hook FlutterView fail!", e);
        }
    }

}
