//
//  FlutterIntegrationViewController.m
//  IGame
//
//  Created by junshao on 2019/9/3.
//  Copyright © 2019 Tencent. All rights reserved.
//

#import "FlutterIntegrationViewController.h"
#import "FlutterIntegrationSwizzle.h"

@interface FlutterIntegrationViewController()

@property (nonatomic, assign) BOOL appearing;

@end

@implementation FlutterIntegrationViewController

- (instancetype)init
{
    self = [super init];
    if (self) {
        self.view.backgroundColor = [UIColor whiteColor];
        UIView *view = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];
        self.splashScreenView = view;
    }
    return self;
}

- (void)fi_updateViewportMetrics {
    if (self.appearing) {
        [self fi_updateViewportMetrics];
    }
}

-(void)viewDidLoad{
    self.appearing = YES;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        FlutterIntegrationSwizzleMethod(NSClassFromString(@"FlutterIntegrationViewController"), NSSelectorFromString(@"updateViewportMetrics"), NSClassFromString(@"FlutterIntegrationViewController"), NSSelectorFromString(@"fi_updateViewportMetrics"));
    });
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

-(void)viewDidAppear:(BOOL)animated {
    self.appearing = YES;
    [self viewDidLayoutSubviews];
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
    self.appearing = NO;
    [super viewWillDisappear:animated];
}

- (void)dealloc {
    [EAGLContext setCurrentContext:nil];
}

@end
