import 'package:flutter/material.dart';
import 'package:flutter_integration/Tools/IntegrationLogger.dart';
import 'package:flutter_integration/flutter_integration.dart';

class IntegrationPageContainer extends StatefulWidget {
  const IntegrationPageContainer({Key key}) : super(key: key);

  @override
  State<StatefulWidget> createState() => IntegrationPageContainerState();
}

class IntegrationPageContainerState extends State<IntegrationPageContainer> {
  List<Widget> _pageList = List<Widget>();
  int _currentIndex = 0;

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return IndexedStack(
      children: _pageList,
      index: _currentIndex,
    );
  }

  void openPage(String routeName, String pageId, var params) {
    bool isExist = false;
    for (int i = _pageList.length - 1; i >= 0; i--) {
      PageWrapper container = _pageList[i];
      if (container.pageId == pageId) {
        isExist = true;
        _currentIndex = i;
        break;
      }
    }
    if (isExist) {
      IntegrationLogger.log('pageId exist');
    } else {
      PageWrapper container = PageWrapper(
        pageId: pageId,
        key: GlobalKey(),
        child:
            FlutterIntegration.router?.getWidgetByRouteName(routeName, params),
      );
      _pageList.add(container);
      _currentIndex = _pageList.length - 1;
    }
    int hashCode = _pageList.hashCode;
    IntegrationLogger.log('_pageList:{$_pageList} hashCode:$hashCode');
    IntegrationLogger.log('_currentIndex:$_currentIndex');
    IntegrationLogger.log('\n');
    setState(() {});
  }

  void removePage(String pageId) {
    for (int i = _pageList.length - 1; i >= 0; i--) {
      PageWrapper container = _pageList[i];
      if (container.pageId == pageId) {
        _pageList.removeAt(i);
        break;
      }
    }
  }
}

class PageWrapper extends Container {
  PageWrapper({
    @required this.pageId,
    Key key,
    Widget child,
  }) : super(key: key, child: child);

  final String pageId;
}
